<?php

if (!defined('SMF'))
	die('Hacking attempt...'); 

function feature_user_actions(&$actionArray)
{
	$actionArray['featureuser'] = array('Subs-FeaturedUsers.php', 'FeatureUserToggle');
}
	
function FeatureUserToggle() 
{
	global $user_info, $user_profile, $context, $smcFunc, $txt;

	checkSession('get');

	isAllowedTo('featureuser');
	is_not_guest();

	if (empty($_REQUEST['u']))
		fatal_lang_error('no_access', false);
		
	$_REQUEST['u'] = (int) $_REQUEST['u'];

	$query = $smcFunc['db_query']('', '
		SELECT featureuser FROM {db_prefix}members
		      WHERE id_member = {int:member}',
		array(
			'member' => $_REQUEST['u'],
		)
	);
	
	if($row = $smcFunc['db_fetch_row']($query)) 
	{
		$value = ($row[0] == 0) ? 1 : 0;
		updateMemberData($_REQUEST['u'], array('featureuser' => $value));
	}

	redirectexit('action=profile;u=' . $_REQUEST['u']);
}

function FeaturedIndex()
{
    global $context, $smcFunc, $db_prefix, $scripturl, $modSettings;
	
	$modSettings['featured_limit'] = !empty($modSettings['featured_limit']) ? (int) $modSettings['featured_limit'] : 5 ; 
	
	$featured_users = $smcFunc['db_query']('', '
      SELECT mem.id_member, mem.real_name, mem.avatar, mem.posts, mem.date_registered, mem.last_login, mg.online_color,
		   IFNULL(a.id_attach, 0) AS id_attach, a.filename, a.attachment_type
           FROM {db_prefix}members mem 	   
	  LEFT JOIN {db_prefix}membergroups mg 
	       ON (mem.id_group = mg.id_group)
	  LEFT JOIN {db_prefix}attachments AS a ON (a.id_member = mem.id_member)  
          WHERE featureuser = {int:featured} 
	       ORDER BY RAND()
	  LIMIT ' . $modSettings['featured_limit'],
      array(
         'featured' => 1, 
      )
   );

   $context['featured_users'] = array();

    while ($row = $smcFunc['db_fetch_assoc']($featured_users))
    {
      $context['featured_users'][] = 
	      array(
                 'posts' => $row['posts'],
		         'joindate' => strftime('%d-%m-%Y', $row['date_registered']),
                 'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '" style="color: ' . $row['online_color'] . ';">' . $row['real_name'] . '</a>',
				 'last_login' => strftime('%d-%m-%Y', $row['last_login']),
		         'avatar' => array(
						'name' => $row['avatar'],
						'image' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? '<img src="' . (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) . '" alt="" class="avatar" border="0" />' : '') : (stristr($row['avatar'], 'http://') ? '<img src="' . $row['avatar'] . '" alt="" class="avatar" border="0" />' : '<img src="' . $modSettings['avatar_url'] . '/' . htmlspecialchars($row['avatar']) . '" alt="" class="avatar" border="0" />'),
						'href' => $row['avatar'] == '' ? ($row['id_attach'] > 0 ? (empty($row['attachment_type']) ? $scripturl . '?action=dlattach;attach=' . $row['id_attach'] . ';type=avatar' : $modSettings['custom_avatar_url'] . '/' . $row['filename']) : '') : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar']),
						'url' => $row['avatar'] == '' ? '' : (stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar'])
				 ),
         );
    }
	
   $smcFunc['db_free_result']($featured_users);
}

function load_permissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{ 
	$permissionList['membergroup']['featureuser'] = array(false, 'member_admin', 'moderate_general');
}

function FeatureAdminArea(&$admin_areas)
{
	global $txt;
	return $admin_areas['config']['areas']['modsettings']['subsections'] += array('featuredusers' => array(sprintf($txt['featuredusers_settings'])));
}

function FeatureSubAction(&$subActions)
{
	return $subActions += array('featuredusers' => 'FeatureSettings');
}

function FeatureSettings($return_config = false) 
{
	global $context, $txt, $scripturl, $modSettings, $settings;

	$context['page_title'] = $txt['featuredusers_settings'];
	
	$config_vars = array(
		array('check', 'featured_users_board_index'),
		array('text', 'featured_limit'),
		array('check', 'featured_user_postbit_enable'),
		array('check', 'featured_user_profile_enable'),
	);

	if ($return_config)
		return $config_vars;

	if (isset($_GET['save'])) 
	{
		checkSession();

		saveDBSettings($config_vars);
		writeLog();

		redirectexit('action=admin;area=modsettings;sa=featuredusers');
	}

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=featuredusers';

	prepareDBSettingContext($config_vars);
}